# Original source: https://about.gitlab.com/blog/2020/07/10/jenkins-migration/

# This scenario uses a followup job that checks for any findings in any scanner
# since it does not depend on the configuration of the containers of individual 
# analyzers, it will work more reliably than the scenario of failing specific
# scanner stages

stages:
  - test
  - verify

include:
  - template: SAST.gitlab-ci.yml

sast:
  stage: test
  variables:
    CI_DEBUG_TRACE: "true"
  allow_failure: true
  artifacts:
    paths:
      - gl-sast-report.json
    reports:
      sast: gl-sast-report.json

sast-findings-fail-pipeline:
  image: alpine
  stage: verify
#  needs:
#    - job: sast
#      artifacts: true
  script:
    - |
      apk add jq
      
      #Help Needed for:
      # filter based on severity
      # output new artifact file (maybe junit?) containing the vulnerabilities that caused failure and note the scanner (data is in the json)

      export VULNS=$(jq '.vulnerabilities | length' gl-sast-report.json)
      if [ "$VULNS" != '0' ]; then 
        echo "Failing due to findings in Security Scanning"
        exit 1; 
      fi
  allow_failure: false
